% script qrs detection all

[~,name,~] = fileparts(recordName);
signame = {'ECG'};

if ~exist('anns','dir')
    mkdir('anns');
end

if ~USE_COMPUTED_QRS
    mat2wfdb(ecg,[name '_ecg'],fs,str2double(siginfo.fmt),siginfo.Units,[],[],signame);
    % = run gqrs
    gqrs([name '_ecg']);
    % = run wqrs
    wqrs([name '_ecg']);
    % = jqrs
    jqrs = run_qrsdet_by_seg(ecg',fs,opt);
    save(['anns/' name '_jqrs'],'jqrs');
    % = epltd
    ecg_rs = resample(ecg,200,fs);
    mat2wfdb([ecg_rs; ecg_rs],[name '_ecg_epltd'],200,str2double(siginfo.fmt),siginfo.Units,[],[],{'V5'});
    system(['./epltd_all -r ' name '_ecg_epltd']);

    % = move to anns folder
    system(['mv ' name '_ecg.dat' ' anns/']);
    system(['mv ' name '_ecg.hea' ' anns/']);
    system(['mv ' name '_ecg.qrs' ' anns/']);
    system(['mv ' name '_ecg.wqrs' ' anns/']);
    system(['mv ' name '_ecg_epltd.dat' ' anns/']);
    system(['mv ' name '_ecg_epltd.hea' ' anns/']);
    system(['mv ' name '_ecg_epltd.epltd0' ' anns/']);
end

try
    [epltd,type,subtype,chan,num,comments]=rdann(['anns/' name '_ecg_epltd'],'epltd0');
    epltd = ceil(epltd*(fs/200));
    ind_rmv = epltd<NB_PT; 
    epltd(ind_rmv) = [];
    type(ind_rmv) = [];
    epltd = epltd-NB_PT+1;
    
    %save(['anns/' name '_epltd'],'epltd'); % FIXME
    %load(['anns/' name '_epltd']);
catch
    epltd = [];
end

try
    load(['anns/' name '_jqrs']); % FIXME
%     jqrs = adjust_mqrs_location(ecg,jqrs,fs,sign(median(ecg(jqrs))));
%     jqrs = jqrs';
catch
    jqrs = [];
end

try
    anns_gqrs = rdann(['anns/' name '_ecg'],'qrs');
    
    %load(['anns/' name '_gqrs']);
    %save(['anns/' name '_gqrs'],'anns_gqrs'); % FIXME
catch
    anns_gqrs = [];
end

% try
%     anns_wqrs = rdann(['anns/' name '_ecg'],'wqrs');
% catch
%     anns_wqrs = [];
% end

anns_wqrs = [];