#! /bin/bash
#
# file: setup.sh
#
# This bash script performs any setup necessary in order to test your
# entry.  It is run only once, before running any other code belonging
# to your entry.



set -e
set -o pipefail

# Example: compile a C module (viterbi_Schmidt) for Octave
#mkoctfile -mex viterbi_Springer.c

# Example: compile a C module for Matlab
#mex viterbi_Springer.c

#chmod a+x mcode/nativelibs/linux/bin/*

# Compiling svmpredict
mex -largeArrayDims svmpredict.c svm.cpp svm_model_matlab.c

# Compiling epltd
cd epltd/
sed 's|(\([0-9]*\)/ *MS_PER_SAMPLE + 0.5)|((\1*SAMPLE_RATE+500)/1000)|' -i qrsdet.h
make
cp 'epltd_all' ../
cd ..



